/*
 * Copyright (c) 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)loginal.c	8.1 (Berkeley) 6/4/93 +pasa";
#endif /* LIBC_SCCS and not lint */

#include <sys/types.h>
#include <sys/param.h>

#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <utmp.h>
#include <stdio.h>

#include "own_wtmp.h"
#include "libutil.h"

#ifdef __linux__
 #define MAX(a,b) ((a < b) ? b : a)
#endif

void
loginal(ut, alias, logmode)
	struct utmp *ut;
	char *alias;
	int logmode;
{
	register int fd;
	int tty = 0,
	    ttya = 0;
        char host[UT_HOSTSIZE];

	if((ttya = t_ttyslot(ut->ut_line, alias)) > 0 ||
	   (tty = t_ttyslot(ut->ut_line, ut->ut_host)) > 0)
	 {
          host[0] = '\0';
        
	  switch(logmode)
	   {
	    case UTMP_LOG_ASIS:
	      if(ttya <= 0)
	        break;
	    case UTMP_LOG_ALIAS:
	      strncpy(host, ut->ut_host, UT_HOSTSIZE);
              host[UT_HOSTSIZE-1] = '\0';
              strncpy(ut->ut_host, alias, UT_HOSTSIZE);
              ut->ut_host[UT_HOSTSIZE-1] = '\0';
	      break;
	   }
	 
	 if ((fd = open(_PATH_UTMP, O_WRONLY|O_CREAT, 0644)) >= 0) {
		(void)lseek(fd, (off_t)(MAX(tty, ttya) * sizeof(struct utmp)), L_SET);
		(void)write(fd, ut, sizeof(struct utmp));
		(void)close(fd);
	 }
	 if ((fd = open(_PATH_WTMP, O_WRONLY|O_APPEND, 0)) >= 0) {
		(void)write(fd, ut, sizeof(struct utmp));
		(void)close(fd);
	 }
	 
	 if(host[0] != '\0')
	   strcpy(ut->ut_host, host);
	}
}
